import peasy.*;

PeasyCam cam;

PVector p1 = new PVector(100, 100, 0);
PVector pAfterTransform;
PVector pAfterInvTransform;

PMatrix3D  xform = new PMatrix3D();
PMatrix3D  invXForm;

float    angle = 45;
PVector  trans = new PVector(0, 0, 50);

void setup()
{
  // set the window size + 3d mode
  size(800, 600, P3D);

  // setup the camera
  cam = new PeasyCam(this, 1500);
  cam.setMinimumDistance(5);
  cam.setMaximumDistance(5000);
  perspective(radians(25), (float)width / (float)height, .1, 5000);

  xform.reset();
  xform.rotate(radians(angle), 0, 0, 1);
  xform.translate(trans.x, trans.y, trans.z);

  invXForm = xform.get();
  invXForm.invert();

  pAfterTransform    = xform.mult(p1, null);
  pAfterInvTransform = invXForm.mult(pAfterTransform, null);
  
}

void draw()
{
  background(0);

  coordSys(100);

  // points
  strokeWeight(5);
  stroke(255, 0, 150);
  point(pAfterTransform.x, pAfterTransform.y, pAfterTransform.z);
  
  stroke(255,255,150);
  point(pAfterInvTransform.x, pAfterInvTransform.y, pAfterInvTransform.z);
  strokeWeight(1);
  
   stroke(255,0,255);
   line(0,0,0,
        p1.x,p1.y,p1.z);
 
}

// draws a simple coordinate system
void coordSys(float size)
{
  pushStyle();

  stroke(255, 0, 0);
  line(0, 0, 0, 
  size, 0, 0);

  stroke(0, 255, 0);
  line(0, 0, 0, 
  0, size, 0);

  stroke(0, 0, 255);
  line(0, 0, 0, 
  0, 0, size);

  popStyle();
}

